<?php
/**
 * Module EiCaptcha
 * (Re)Captcha pour Prestashop
 *
 * © h-hennes 2013-2014 
 * http://www.h-hennes.fr/blog/
 */
 
 // Security
if (!defined('_PS_VERSION_'))
        exit;
 
 class EiCaptcha extends Module {
 
		private $_html = '';
 
		public function __construct() {
 
         $this->author = 'hhennes';
         $this->name = 'eicaptcha';
         $this->tab = 'hhennes';        
         $this->version = '0.2.1';
         $this->need_instance = 1;
        
         parent::__construct();
                
        $this->displayName = $this->l('Ei Captcha');
        $this->description = $this->l('Add a captcha to your website form');
                 
        
        if ($this->active && ( !Configuration::get('CAPTCHA_PUBLIC_KEY') || !Configuration::get('CAPTCHA_PRIVATE_KEY')  ) )
           $this->warning = $this->l('Captcha Module need to be configurated'); 
		   
		   
		/* Backward compatibility */
		if (_PS_VERSION_ < '1.5')
           require(_PS_MODULE_DIR_.$this->name.'/backward_compatibility/backward.php');   
 
		}
		
		
		public function install() {
		
			if ( !parent::install() || !$this->registerHook('header') || !$this->registerHook('displayCustomerAccountForm') || !Configuration::updateValue('CAPTCHA_ENABLE_ACCOUNT',0) )
				return false;
			
			return true;
		
		}
		
		public function uninstall() {
		
			if ( !parent::uninstall() )
				return false;
		
			if ( !Configuration::deleteByName('CAPTCHA_PUBLIC_KEY') || !Configuration::deleteByName('CAPTCHA_PRIVATE_KEY')  || !Configuration::deleteByName('CAPTCHA_ENABLE_ACCOUNT') )
				return false;
				
			return true;
		}
		
		
		public function postProcess()  {
				
		if ( Tools::isSubmit('SubmitCaptchaConfiguration') )
			{		
				Configuration::updateValue('CAPTCHA_PUBLIC_KEY', Tools::getValue('captcha_public_key'));
				Configuration::updateValue('CAPTCHA_PRIVATE_KEY', Tools::getValue('captcha_private_key'));
				Configuration::updateValue('CAPTCHA_ENABLE_ACCOUNT', Tools::getValue('captcha_enable_account'));
			}
		
		}
		
		
		public function getContent(){
		
		
			$this->postProcess();
			$this->_html .=  
			'<fieldset>
					<legend>'.$this->l('Captcha Configuration').'</legend>
					<h2>'.$this->l('Captcha Configuration').'</h2>
					<p>'.$this->l('To get your own public and private keys please click on the folowing link').'<br />
					<a href="https://www.google.com/recaptcha/admin#whyrecaptcha" target="_blank">https://www.google.com/recaptcha/admin#whyrecaptcha</a>
					</p>
					<br />
					<form name="captcha_configuration" method="post" action="'.$_SERVER['REQUEST_URI'].'">
					<br />
					 <br class="clear" />
					 <label for="captcha_private_key">'.$this->l('Private Key').'</label>
					 <input type="text" name="captcha_private_key" value="'.Configuration::get('CAPTCHA_PRIVATE_KEY').'" />
					 <br />
					 <br class="clear" />
					 <label for="captcha_public_key">'.$this->l('public Key').'</label>
					 <input type="text" name="captcha_public_key" value="'.Configuration::get('CAPTCHA_PUBLIC_KEY').'" />
					 <br class="clear" />
					 <label for="captcha_enable_account">'.$this->l('Enable Captcha for account creation').'</label>
					 <br class="clear" />
					 <div>
					 <label>'.$this->l('Yes').'</label>
					 <input type="radio" name="captcha_enable_account" value="1" ';
					 if ( Configuration::get('CAPTCHA_ENABLE_ACCOUNT') == 1 )
						$this->_html .= 'checked="checked"';
					$this->_html.='/>	
					 <br class="clear" />
					 <label>'.$this->l('No').'</label>
					 <input type="radio" name="captcha_enable_account" value="0" ';
					 if ( Configuration::get('CAPTCHA_ENABLE_ACCOUNT') == 0 ) 
						$this->_html .= 'checked="checked"';
					$this->_html.='/>
					 </div>
					<br />
					<br class="clear" />
					<input type="submit" name="SubmitCaptchaConfiguration" class="button" value="Envoyer" style="margin-left:200px"/>
					</form>
			</fieldset>';
		
		
			return $this->_html;
		}
		
		
		/**
		 * Hook Header pour le formulaire de contact
		 */
		public function hookHeader($params) {
		
					
			//Récupération de la page//controller courant
			$contact_form_controller = false;
			$page_name = false;
			
			//Version 1.5
			if (_PS_VERSION_ > '1.5') {
				if ( $this->context->controller instanceof ContactController )
					$contact_form_controller = true;
			}
			//Versions 1.4
			else {
				/* Version >= 1.4.9 */
				if ( version_compare(_PS_VERSION_, '1.4.9.0', '>=') )
					$page_name = $this->context->smarty->getTemplateVars('page_name');
				else  	
				/* Version < 1.4.9*/
				$page_name = $this->context->smarty->get_template_vars('page_name');
			}
			
			
			if ( $page_name == 'contact-form' || $contact_form_controller )
			 return $this->_displayCaptchaContactForm();
			 
		}
		
		/**
		 * Actions ajax du module ( Prestashop v 1.4 )
		 */ 
		public function hookAjaxCall() {
		
			$action = Tools::getValue('action');
			require_once(dirname(__FILE__).'/lib/recaptchalib.php');
		
			if ( $action == 'validate_captcha' ) {
			
				$recaptcha_challenge_field = Tools::getValue('recaptcha_challenge_field');
				$recaptcha_response_field =  Tools::getValue('recaptcha_response_field');
								
				$captcha_check = recaptcha_check_answer(Configuration::get('CAPTCHA_PRIVATE_KEY'), $_SERVER["REMOTE_ADDR"], Tools::getValue('recaptcha_challenge_field'), Tools::getValue('recaptcha_response_field'));						
				
				if ($captcha_check->is_valid != 1)
				{
					//Assignation de l'erreur au template
					$this->context->smarty->assign('errors',array($this->l('Please validate the captcha field before submitting your request')));
					$errorBlock = trim(preg_replace("#\n#","",$this->context->smarty->fetch(_PS_THEME_DIR_.'errors.tpl')));
					echo $errorBlock;
				}
				else 
				 return '';
			}
		}
 
 
		/**
		 * Rajout des champs au formulaire de création de compte
		 */
		public function hookDisplayCustomerAccountForm($params){
			if ( Configuration::get('CAPTCHA_ENABLE_ACCOUNT') == 1 ) {	
				//Génération du template
				require_once(dirname(__FILE__).'/lib/recaptchalib.php');
				$publickey = Configuration::get('CAPTCHA_PUBLIC_KEY');
				
				//Recaptcha n'est pas compatible ajax à cause du document.write, on va donc créer un fichier qui corrige cette erreur
				//@ToDo : Gérer un système de cache pour éviter de vérifier le fichier à chaque fois
				$script = file_get_contents('http://www.google.com/recaptcha/api/js/recaptcha_ajax.js');
				$script = str_replace('document.write','$("body").append',$script);				
				$fp = fopen(dirname(__FILE__).'/js/google_recaptcha_ajax.js','w+');
				fputs($fp,$script);
				fclose($fp);
				
				//Ajout des js globaux
				$this->context->controller->addJS($this->_path.'/js/google_recaptcha_ajax.js');
				$this->context->controller->addJS($this->_path.'/js/eicaptcha.js');
				
				if ( _PS_VERSION_ > '1.6') {
					$errorSelector = '.alert';
					$formSelector = '#account-creation_form';
					$prestashopVersion = "16";
				}
				else {
					$this->context->controller->addCSS($this->_path.'/css/eicaptcha.css');
					$errorSelector = '.error';
					$formSelector = '#account-creation_form';
					$prestashopVersion = "15";
				}
				
				//Assignation des variables nécessaires au bon fonctionnement du module
				$this->context->smarty->assign('publicKey',$publickey);
				$this->context->smarty->assign('waiting_message',$this->l('Please wait during captcha check'));
				$this->context->smarty->assign('checkCaptchaUrl',_MODULE_DIR_.$this->name.'/eicaptcha-ajax.php');
				$this->context->smarty->assign('errorSelector',$errorSelector);
				$this->context->smarty->assign('formSelector',$formSelector);
				$this->context->smarty->assign('prestashopVersion',$prestashopVersion);

				return $this->display(__FILE__,'hookDisplayCustomerAccountForm.tpl');
			}
		}
 
		
		/**
		 * Affichage du captcha sur la page du formulaire de contact
		 */
		private function _displayCaptchaContactForm() {
		
			//Génération du template
			require_once(dirname(__FILE__).'/lib/recaptchalib.php');
		
			$publickey = Configuration::get('CAPTCHA_PUBLIC_KEY');
			$moveCaptchaWithJsDefer = '';
					
				//Si le https est actif sur le site il faut également l'activer dans le captcha
				if ( Configuration::get('PS_SSL_ENABLED') == 1 )
					$sslMode = true;
				else
					$sslMode = false;
				
				//Récupération du code captcha et assignation de la variable au template
				$this->context->smarty->assign('captcha',recaptcha_get_html($publickey,null,$sslMode));
				
				/**
				 * Version 1.6 (Thème default-bootstrap )
				 * Les noms des classes des éléments par défaut sont différents
				 * Gestion des nom des classes pour que le module soit compatible avec l'ensemble des versions
				 */
				if ( _PS_VERSION_ > '1.6') {
				
					$errorClass = 'alert';
					$formClass = 'contact-form-box';
				
					//Avec la fonctionnalité js_defer qui place tout le javascript inline en fin de page le captcha ne s'affiche pas au bon endroit
					//On laisse le temps au captcha de se charger et on le place à l'endroit souhaité dans le DOM
					if ( Configuration::get('PS_JS_DEFER') == 1 ) {	
						$moveCaptchaWithJsDefer = "	
						 setTimeout(function(){
							captchaContent = $('#recaptcha_widget_div').clone();
							$('#recaptcha_widget_div').remove();
							$('#captcha-box').append(captchaContent);
						 },1000);
						";
					}
				
				}
				else {
					$errorClass = 'error';
					$formClass = 'std';
				}
				
				return '
				<script type="text/javascript">
					$(document).ready(function(){
		
						var validationPassed = false;
						var test=0;
						//Pour lancer la validation du formulaire on lance la vérification du captcha
						$("#submitMessage").click(function(){
						
							if ( validationPassed )
								$("form.'.$formClass.'").submit();
						
							var waiting_message = "'.$this->l('Please wait during captcha check').'";
							if ( $(".load").length )
								$(".load").html("").html(waiting_message);
							else	
								$(this).after("<div class=\"load\">"+waiting_message+"</div>");
							
							$.ajax({
								method : "POST",
								url : "'._MODULE_DIR_.$this->name.'/eicaptcha-ajax.php",
								data : "action=validate_captcha&recaptcha_challenge_field="+$("#recaptcha_challenge_field").val()+"&recaptcha_response_field="+$("#recaptcha_response_field").val(),
								success : function(msg){
									$(".load").html("");
									if ( msg != "") {
									  $(".'.$errorClass.'").remove();	
									  $("form.'.$formClass.'").before(msg);
									  if ( $(".'.$errorClass.'").length )
										$("html, body").animate({scrollTop:$(".'.$errorClass.'").offset().top  },"slow");  
									}
									else {
									 if ( $(".'.$errorClass.'").length )
										$(".'.$errorClass.'").remove();
										validationPassed = true;
										//Bug dans la soumission du formulaire on insère la valeur du submit
										$("form.'.$formClass.'").append("<input type=\'hidden\' name=\'submitMessage_x\' value=\'send\' />");
										$("form.'.$formClass.'").submit();
									}
								}
							});
							return false;
						});
					
					'.$moveCaptchaWithJsDefer.'
					});
				</script>
				';	
		
		
		}
 
 }





?>